<template>
  <div v-if="isVisible">
    <IdGrafico id="010" />
    <v-card
      :loading="isLoadingCumplimientoDisciplinaPuntoContacto"
      tile
      raised
      elevation="3"
    >
      <div></div>
      <div class="title-card-component">
        Cumplimiento de la disciplina por los negocios que componen
        <span
          v-if="globalFilters && globalFilters.filters.descripcion_ceco"
          class="bold keep-spaces"
          >{{ " " + globalFilters.filters.id_ceco }} -
          {{ globalFilters.filters.descripcion_ceco }}</span
        >
      </div>
      <div class="cardBoby">
        <div class="grafica">
          <v-skeleton-loader
            type="list-item-avatar"
            tile
            class="mx-auto"
            v-show="isLoadingCumplimientoDisciplinaPuntoContacto"
          ></v-skeleton-loader>
          <v-skeleton-loader
            type="list-item-avatar"
            tile
            class="mx-auto"
            v-show="isLoadingCumplimientoDisciplinaPuntoContacto"
          ></v-skeleton-loader>
          <v-skeleton-loader
            type="list-item-avatar"
            tile
            class="mx-auto"
            :loading="isLoadingCumplimientoDisciplinaPuntoContacto"
          >
            <span class="bold">Negocios</span>
            <template
              v-for="(itemNegocioDisciplina,
              indexItemNegocioDisciplina) in negociosDisciplina"
            >
              <div :key="indexItemNegocioDisciplina" class="negocio">
                <div class="imga">
                  <v-img
                    :contain="true"
                    :aspect-ratio="1"
                    position="center"
                    :src="itemNegocioDisciplina.logo_image"
                    :lazy-src="itemNegocioDisciplina.logo_image"
                  />
                </div>
                <div class="medidor">
                  <div
                    class="porcentaje text-center"
                    v-bind:style="{
                      width: itemNegocioDisciplina.calificacion + '%',
                      backgroundColor: itemNegocioDisciplina.rango.detalle
                    }"
                  >
                    {{ itemNegocioDisciplina.calificacion }}%
                  </div>
                </div>
              </div>
            </template>
          </v-skeleton-loader>
        </div>
      </div>
    </v-card>
  </div>
</template>
<style scoped>
.keep-spaces {
  white-space: pre-wrap;
}
.title-card-component {
  display: flex;
  justify-content: center;
  align-items: center;
  background-color: #1e2945;
  color: white;
  padding: 5px 0px;
}
</style>
<style scoped>
.contenedorCards {
  display: flex;
}
.card {
  margin: 10px;
  min-height: 183px;
  -webkit-box-shadow: 3px 3px 7px 0px rgba(204, 204, 204, 1);
  -moz-box-shadow: 3px 3px 7px 0px rgba(204, 204, 204, 1);
  box-shadow: 3px 3px 7px 0px rgba(204, 204, 204, 1);
}
.cardHeader {
  height: 40px;
  background-color: #f7f7f7;
  display: flex;
  justify-content: space-between;
  align-items: center;
  padding: 20px;
  font-family: "AvenirNextLTPro-Medium";
}
.cardHeader > .porcentaje {
  display: flex;
  justify-content: center;
  align-items: center;
}
.flechas {
  width: 20px;
  margin-left: 10px;
  cursor: pointer;
}
.cardBoby {
  padding: 10px 0px;
}
.grafica {
  padding-top: 5px;
}
.grafica img {
  width: 100%;
}
.negocio {
  display: flex;
  border-top: solid 1px #f7f7f7;
  border-bottom: solid 1px #f7f7f7;
  margin: 5px 0px;
}
.negocio > .imga {
  width: 61px;
  display: flex;
  align-items: center;
  margin-right: 10px;
  padding-left: 10px;
  justify-content: center;
  height: 20px;
}
.negocio > .medidor {
  width: 81%;
  height: 25px;
}
.negocio > .medidor > .porcentaje {
  height: 25px;
  background-color: grey;
  position: relative;
  border-top-right-radius: 21px;
  border-bottom-right-radius: 21px;
  display: flex;
  align-items: center;
  padding-left: 10px;
  color: white;
  justify-content: center;
}
</style>
<script>
import store from "@/store";
import axios from "axios";
import IdGrafico from "@/views/secure/sistema-informacion/dashboards/commons/IdGraficoLabel.vue";
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-CumplimientoDisciplinaPuntoContacto",
  props: {
    methodsSemaforoParent: Object,
    globalFiltersParent: Object
  },
  components: {
    IdGrafico
  },
  data() {
    return {
      isLoadingCumplimientoDisciplinaPuntoContacto: true,
      isPersentValue: true,
      methodsSemaforo: null,
      globalFilters: null,
      negociosDisciplina: [],
      isVisible: true
    };
  },
  methods: {
    listenSearchConsulta(globalFilters) {
      if (globalFilters.final_filters.nivel_geografico == 0) {
        this.isVisible = true;
        this.globalFilters = globalFilters;
        this.getCumplimientoDisciplinaPuntoContacto();
      } else {
        this.isVisible = false;
      }
    },
    listenSemaforo(methodsSemaforo) {
      this.methodsSemaforo = methodsSemaforo;
    },
    getCumplimientoDisciplinaPuntoContacto() {
      this.isLoadingCumplimientoDisciplinaPuntoContacto = true;
      const self = this;
      const contentFiltros = {
        filtros: this.globalFilters.final_filters
      };
      axios
        .post(
          "franquicia/dashboard/secure/grafico/get/cumplimiento/disciplina/punto/contacto",
          contentFiltros
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setCumplimientoDisciplinaPuntoContacto(data);
              }
            } else {
              self.setCumplimientoDisciplinaPuntoContacto([]);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isLoadingCumplimientoDisciplinaPuntoContacto = false;
        });
    },
    setCumplimientoDisciplinaPuntoContacto(negociosDisciplina) {
      const self = this;
      negociosDisciplina = negociosDisciplina.map((itemNegocio) => {
        itemNegocio.logo_image = serviceCommons.getLogoImageByIdNegocio(
          itemNegocio.id_negocio
        );
        itemNegocio.rango = self.methodsSemaforo.getRangoByLimit(
          itemNegocio.calificacion
        );
        return itemNegocio;
      });
      this.negociosDisciplina = negociosDisciplina;
    }
  },
  mounted() {
    this.$root.$on("searchconsulta", this.listenSearchConsulta);
    this.$root.$on("rangoloaded", this.listenSemaforo);
  },
  created() {
    this.methodsSemaforo = this.methodsSemaforoParent;
    this.globalFilters = this.globalFiltersParent;
    if (this.globalFilters) {
      this.getCumplimientoDisciplinaPuntoContacto();
    }
  }
};
</script>
